<?php

if ( ! defined( 'ABSPATH' ) ) {
  exit;
}

if( ! class_exists( 'MywpExtendsWPAUC_Importer' ) ) {
  return false;
}

if ( ! class_exists( 'MywpExtendsWPAUC_Importer_AdminSidebar' ) ) :

final class MywpExtendsWPAUC_Importer_AdminSidebar {

  private static $post_type = 'mywp_admin_sidebar';

  private static function get_default() {

    $default_admin_sidebar = MywpAdminSidebar::get_default_sidebar();

    return $default_admin_sidebar;

  }

  private static function get_transient() {

    $mywp_transient = new MywpTransient( 'importer_default_admin_sidebar' , 'importer' );

    return $mywp_transient;

  }

  public static function get_transient_default_admin_sidebar() {

    $mywp_transient = self::get_transient();

    $transient_default_admin_sidebar = $mywp_transient->get_data();

    if( ! empty( $transient_default_admin_sidebar ) ) {

      return $transient_default_admin_sidebar;

    }

    return false;

  }

  public static function set_default_sidebar_transient() {

    $default_admin_sidebar = self::get_default();

    if( empty( $default_admin_sidebar ) ) {

      MywpSettingScreenWPAUC_Importer::$errors[] = 'Error. It seems Sidebar of My WP Customize not had.';

      return false;

    }

    $mywp_transient = self::get_transient();

    $mywp_transient->update_data( $default_admin_sidebar );

    return true;

  }

  public static function get_default_admin_sidebar_items() {

    $default_sidebar = self::get_transient_default_admin_sidebar();

    if( empty( $default_sidebar ) ) {

      return false;

    }

    if( ! empty( $default_sidebar['menu'] ) ) {

      foreach( $default_sidebar['menu'] as $key => $menu ) {

        $menu_id = $menu[2];

         if( $menu_id === 'edit-comments.php' ) {

           $default_sidebar['menu'][ $key ][0] = sprintf( '%s %s' , __( 'Comments' ) , '[mywp_comment_count tag="1"]' );

         } elseif( $menu_id === 'themes.php' ) {

           $default_sidebar['menu'][ $key ][0] = sprintf( '%s %s' , __( 'Appearance' ) , '[mywp_update_count type="themes" tag="1"]' );

         } elseif( $menu_id === 'plugins.php' ) {

           $default_sidebar['menu'][ $key ][0] = sprintf( '%s %s' , __( 'Plugins' ) , '[mywp_update_count type="plugins" tag="1"]' );

         }

      }

    }

    if( ! empty( $default_sidebar['submenu'] ) ) {

      foreach( $default_sidebar['submenu'] as $parent_id => $submenus ) {

        foreach( $submenus as $key => $submenu ) {

          $menu_id = $submenu[2];

          if( $parent_id === 'index.php' && $menu_id === 'update-core.php' ) {

            $default_sidebar['submenu'][ $parent_id ][ $key ][0] = sprintf( '%s %s' , __( 'Update' ) , '[mywp_update_count type="total" tag="1"]' );

          }

        }

      }

    }

    return $default_sidebar;

  }

  public static function delete_current_sidebar_items() {

    $args = array(
      'post_status' => array( 'publish' , 'draft' ),
      'post_type' => self::$post_type,
      'order' => 'ASC',
      'orderby' => 'menu_order',
      'posts_per_page' => -1,
      'tax_query' => array(
        array(
          'taxonomy' => 'mywp_term',
          'field' => 'slug',
          'terms' => 'default',
        ),
      ),
    );

    $current_setting_sidebar_item_posts = MywpSetting::get_posts( $args );

    if( ! empty( $current_setting_sidebar_item_posts ) ) {

      foreach( $current_setting_sidebar_item_posts as $key => $post ) {

        wp_delete_post( $post->ID );

      }

    }

    $mywp_transient = new MywpTransient( 'admin_sidebar_get_sidebar' , 'controller' );

    $mywp_transient->remove_data();

  }

  private static function get_wpauc_record_data_admin_sidemenu() {

    $wpauc_setting_data = MywpSettingScreenWPAUC_Importer::get_wpauc_record_data( 'sidemenu' );

    if( ! empty( $wpauc_setting_data ) ) {

      foreach( $wpauc_setting_data as $wpauc_menu_location => $wpauc_menus ) {

        foreach( $wpauc_menus as $wpauc_menu_item_key => $wpauc_menu_item ) {

          if( strpos( $wpauc_menu_item['title'] , '[comment_count]' ) ) {

            $wpauc_setting_data[ $wpauc_menu_location ][ $wpauc_menu_item_key ]['title'] = str_replace( '[comment_count]' , '[comment_count_format]' , $wpauc_menu_item['title'] );

          }

          if( strpos( $wpauc_menu_item['title'] , '[update_total]' ) ) {

            $wpauc_setting_data[ $wpauc_menu_location ][ $wpauc_menu_item_key ]['title'] = str_replace( '[update_total]' , '[update_total_format]' , $wpauc_menu_item['title'] );

          }

          if( strpos( $wpauc_menu_item['title'] , '[update_plugins]' ) ) {

            $wpauc_setting_data[ $wpauc_menu_location ][ $wpauc_menu_item_key ]['title'] = str_replace( '[update_plugins]' , '[update_plugins_format]' , $wpauc_menu_item['title'] );

          }

          if( strpos( $wpauc_menu_item['title'] , '[update_themes]' ) ) {

            $wpauc_setting_data[ $wpauc_menu_location ][ $wpauc_menu_item_key ]['title'] = str_replace( '[update_themes]' , '[update_themes_format]' , $wpauc_menu_item['title'] );

          }

          $is_slug_rewrite = false;

          if( strpos( $wpauc_menu_item['slug'] , '&amp;' ) !== false ) {

            $wpauc_menu_item['slug'] = str_replace( '&amp;' , '&' , $wpauc_menu_item['slug'] );

            $is_slug_rewrite = true;

          }

          if( strpos( $wpauc_menu_item['slug'] , '#038;' ) !== false ) {

            $wpauc_menu_item['slug'] = str_replace( '#038;' , '' , $wpauc_menu_item['slug'] );

            $is_slug_rewrite = true;

          }

          if( strpos( $wpauc_menu_item['slug'] , '%5B' ) !== false ) {

            $wpauc_menu_item['slug'] = str_replace( '%5B' , '[' , $wpauc_menu_item['slug'] );

            $is_slug_rewrite = true;

          }

          if( strpos( $wpauc_menu_item['slug'] , '%5D' ) !== false ) {

            $wpauc_menu_item['slug'] = str_replace( '%5D' , ']' , $wpauc_menu_item['slug'] );

            $is_slug_rewrite = true;

          }

          if( $is_slug_rewrite ) {

            $wpauc_setting_data[ $wpauc_menu_location ][ $wpauc_menu_item_key ]['slug'] = $wpauc_menu_item['slug'];

          }

        }

      }

    }

    return $wpauc_setting_data;

  }

  public static function sidebar_regist( $find_parent_item_id = false , $parent_post_id = 0 , $menu_order = 0 ) {

    $find_parent_item_id = strip_tags( $find_parent_item_id );

    $parent_post_id = intval( $parent_post_id );

    $menu_order = intval( $menu_order );

    $wpauc_setting_data = self::get_wpauc_record_data_admin_sidemenu();

    $find_items = array();

    if( $find_parent_item_id == "" ) {

      foreach( $wpauc_setting_data['main'] as $wpauc_menu ) {

        if( (string) $wpauc_menu['parent_slug'] !== (string) $find_parent_item_id ) {

          continue;

        }

        $find_items[] = $wpauc_menu;

      }

      if( empty( $find_items ) ) {

        return false;

      }

      $post_terms = array(
        array( 'taxonomy' => 'mywp_term' , 'term' => 'default' ),
      );

      foreach( $find_items as $find_item ) {

        $add_meta_data = array();

        if( $find_item['slug'] === 'separator' ) {

          $add_meta_data = array(
            'item_type' => 'separator',
            'item_default_type' => 'menu',
            'item_default_id' => '',
            'item_default_parent_id' => '',
          );

        } else {

          $sidebar_find_default_position = self::sidebar_find_default_position( $find_item );

          if( empty( $sidebar_find_default_position ) ) {

            MywpSettingScreenWPAUC_Importer::$errors[] = sprintf( 'Sorry, %s [%s] item can not saved.' , $find_item['slug'] , $find_item['parent_slug'] );

            continue;

          } else {

            $item_icon = self::sidebar_item_icon( $find_item , $sidebar_find_default_position );

            $add_meta_data = array(
              'item_type' => 'default',
              'item_default_type' => 'menu',
              'item_default_id' => $sidebar_find_default_position[2],
              'item_default_parent_id' => '',
              'item_default_title' => $sidebar_find_default_position[0],
              'item_link_title' => MywpSettingScreenWPAUC_Importer::change_shortcode( $find_item['title'] ),
              'item_icon_class' => $item_icon['class'],
              'item_icon_style' => $item_icon['style'],
              'item_icon_img' => $item_icon['img'],
              'item_capability' => $sidebar_find_default_position[1],
            );

          }

        }

        if( empty( $add_meta_data ) ) {

          continue;

        }

        $post_data = array( 'post_parent' => $parent_post_id , 'menu_order' => $menu_order );

        $add_post_id = MywpSettingScreenWPAUC_Importer::add_post( 'mywp_admin_sidebar' , $post_data , $add_meta_data , $post_terms );

        $menu_order++;

        if ( empty( $add_post_id ) ) {

          MywpSettingScreenWPAUC_Importer::$errors[] = sprintf( 'Sorry, %s item of main menu can not add.' , $find_item['slug'] );

          continue;

        } elseif( is_wp_error( $add_post_id ) ) {

          MywpSettingScreenWPAUC_Importer::$errors[] = sprintf( 'Sorry, %s item of main menu can not add [%s].' , $find_item['slug'] , $add_post_id->get_error_message() );

          continue;

        }

        self::sidebar_regist( $find_item['slug'] , $add_post_id , $menu_order );

      }

    } else {

      foreach( $wpauc_setting_data['sub'] as $wpauc_menu ) {

        if( (string) $wpauc_menu['parent_slug'] !== (string) $find_parent_item_id ) {

          continue;

        }

        $find_items[] = $wpauc_menu;

      }

      if( empty( $find_items ) ) {

        return false;

      }

      $post_terms = array(
        array( 'taxonomy' => 'mywp_term' , 'term' => 'default' ),
      );

      foreach( $find_items as $find_item ) {

        $add_meta_data = array();

        $sidebar_find_default_position = self::sidebar_find_default_position( $find_item );

        if( empty( $sidebar_find_default_position ) ) {

          MywpSettingScreenWPAUC_Importer::$errors[] = sprintf( 'Sorry, %s [%s] sub item can not saved.' , $find_item['slug'] , $find_item['parent_slug'] );

          continue;

        } else {

          $add_meta_data = array(
            'item_type' => 'default',
            'item_default_type' => 'submenu',
            'item_default_id' => $sidebar_find_default_position[2],
            'item_default_parent_id' => $sidebar_find_default_position['parent_slug'],
            'item_default_title' => $sidebar_find_default_position[0],
            'item_link_title' => MywpSettingScreenWPAUC_Importer::change_shortcode( $find_item['title'] ),
            'item_capability' => $sidebar_find_default_position[1],
          );

        }

        if( empty( $add_meta_data ) ) {

          continue;

        }

        $post_data = array( 'post_parent' => $parent_post_id , 'menu_order' => $menu_order );

        $add_post_id = MywpSettingScreenWPAUC_Importer::add_post( 'mywp_admin_sidebar' , $post_data , $add_meta_data , $post_terms );

        if ( empty( $add_post_id ) ) {

          MywpSettingScreenWPAUC_Importer::$errors[] = sprintf( 'Sorry, %s item of sub menu can not add.' , $find_item['slug'] );

          continue;

        } elseif( is_wp_error( $add_post_id ) ) {

          MywpSettingScreenWPAUC_Importer::$errors[] = sprintf( 'Sorry, %s item of sub menu can not add [%s].' , $find_item['slug'] , $add_post_id->get_error_message() );

          continue;

        }

      }

    }

  }

  private static function sidebar_find_default_position( $find_item ) {

    if( empty( $find_item ) ) {

      return false;

    }

    $admin_sidebar_items = self::get_default_admin_sidebar_items();

    $found_menu = false;

    if( $find_item['parent_slug'] == "" ) {

      foreach( $admin_sidebar_items['menu'] as $menu ) {

        if( $menu[2] === $find_item['slug'] ) {

          $found_menu = $menu;

          break;

        }

      }

    } else {

      foreach( $admin_sidebar_items['submenu'] as $parent_slug => $sms ) {

        if( $parent_slug !== $find_item['parent_slug'] ) {

          continue;

        }

        foreach( $sms as $menu ) {

          if( $menu[2] === $find_item['slug'] ) {

            $found_menu = $menu;

            $found_menu['parent_slug'] = $parent_slug;

            break;

          }

        }

      }

    }

    return $found_menu;

  }

  private static function sidebar_item_icon( $item , $sidebar_find_default_position ) {

    $item_icon = array( 'class' => '' , 'style' => '' , 'img' => '' );

    if( ! empty( $sidebar_find_default_position[6] ) ) {

      if( strpos( $sidebar_find_default_position[6] , 'data:image/svg+xml;base64,' ) ) {

        $item_icon['class'] = ' svg';
        $item_icon['style'] = sprintf( ' background-image: url( "%s" );' , esc_attr( $sidebar_find_default_position[6] ) );

      } elseif( strpos( $sidebar_find_default_position[6] , 'dashicons-' ) !== false ) {

        $item_icon['class'] = sprintf( ' dashicons-before %s ' , $sidebar_find_default_position[6] );

      } elseif( $sidebar_find_default_position[6] === 'none' or $sidebar_find_default_position[6] === 'div' ) {

        $item_icon['class'] = ' dashicons-before ';

      } elseif( strpos( $sidebar_find_default_position[6] , 'http' ) !== false ) {

        $item_icon['img'] = $sidebar_find_default_position[6];

      } else {

        $item_icon['class'] = $sidebar_find_default_position[6];

      }

    }

    return $item_icon;

  }

}

endif;
