<?php

if ( ! defined( 'ABSPATH' ) ) {
  exit;
}

if( ! class_exists( 'MywpExtendsWPAUC_Importer' ) ) {
  return false;
}

if ( ! class_exists( 'MywpExtendsWPAUC_Importer_AdminToolbar' ) ) :

final class MywpExtendsWPAUC_Importer_AdminToolbar {

  private static $post_type = 'mywp_admin_toolbar';

  private static function get_default() {

    $default_admin_toolbar = MywpAdminToolbar::get_default_toolbar();

    return $default_admin_toolbar;

  }

  private static function get_transient() {

    $mywp_transient = new MywpTransient( 'importer_default_admin_toolbar' , 'importer' );

    return $mywp_transient;

  }

  public static function get_transient_default_admin_toolbar() {

    $mywp_transient = self::get_transient();

    $transient_default_admin_toolbar = $mywp_transient->get_data();

    if( ! empty( $transient_default_admin_toolbar ) ) {

      return $transient_default_admin_toolbar;

    }

    return false;

  }

  public static function set_default_toolbar_transient() {

    $default_admin_toolbar = self::get_default();

    if( empty( $default_admin_toolbar ) ) {

      MywpSettingScreenWPAUC_Importer::$errors[] = 'Error. It seems Toolbar of My WP Customize not had.';

      return false;

    }

    $mywp_transient = self::get_transient();

    $mywp_transient->update_data( $default_admin_toolbar );

    return true;

  }

  public static function get_default_admin_toolbar_items() {

    $default_toolbar = self::get_transient_default_admin_toolbar();

    if( empty( $default_toolbar ) ) {

      return false;

    }

    foreach( $default_toolbar as $menu_location => $menus ) {

      foreach( $menus as $key => $menu ) {

        $default_toolbar[ $menu_location ][ $key ]->capability = false;

        if( $menu->id === 'user-info' ) {

          $default_toolbar[ $menu_location ][ $key ]->title = sprintf( '%s <span class="display-name">%s</span>' , '[mywp_user field="avatar" size="64"]' , '[mywp_user field="name"]' );

        } elseif( $menu->id === 'logout' ) {

          $default_toolbar[ $menu_location ][ $key ]->href = '[mywp_url logout="1"]';

        } elseif( $menu->id === 'my-account' ) {

          $howdy  = sprintf( __( 'Howdy, %s' ), '<span class="display-name">[mywp_user field="name"]</span>' );
          $default_toolbar[ $menu_location ][ $key ]->title = $howdy . '[mywp_user field="avatar" size="64"]';

        } elseif( $menu->id === 'my-sites' ) {

          $default_toolbar[ $menu_location ][ $key ]->href = '[mywp_url admin="1"]my-sites.php';
          $default_toolbar[ $menu_location ][ $key ]->capability = 'manage_network';

        } elseif( $menu->id === 'my-sites-super-admin' ) {

          unset( $default_toolbar[ $menu_location ][ $key ] );

        } elseif( $menu->id === 'network-admin' ) {

          $default_toolbar[ $menu_location ][ $key ]->parent = '';
          $default_toolbar[ $menu_location ][ $key ]->href = '[mywp_url network_admin="1"]';
          $default_toolbar[ $menu_location ][ $key ]->capability = 'manage_network';

        } elseif( $menu->id === 'network-admin-d' ) {

          $default_toolbar[ $menu_location ][ $key ]->href = '[mywp_url network_admin="1"]';
          $default_toolbar[ $menu_location ][ $key ]->capability = 'manage_network';

        } elseif( $menu->id === 'network-admin-s' ) {

          $default_toolbar[ $menu_location ][ $key ]->href = '[mywp_url network_admin="1"]/sites.php';
          $default_toolbar[ $menu_location ][ $key ]->capability = 'manage_sites';

        } elseif( $menu->id === 'network-admin-u' ) {

          $default_toolbar[ $menu_location ][ $key ]->href = '[mywp_url network_admin="1"]/users.php';
          $default_toolbar[ $menu_location ][ $key ]->capability = 'manage_network_users';

        } elseif( $menu->id === 'network-admin-t' ) {

          $default_toolbar[ $menu_location ][ $key ]->href = '[mywp_url network_admin="1"]/themes.php';
          $default_toolbar[ $menu_location ][ $key ]->capability = 'manage_network_themes';

        } elseif( $menu->id === 'network-admin-p' ) {

          $default_toolbar[ $menu_location ][ $key ]->href = '[mywp_url network_admin="1"]/plugins.php';
          $default_toolbar[ $menu_location ][ $key ]->capability = 'manage_network_plugins';

        } elseif( $menu->id === 'network-admin-o' ) {

          $default_toolbar[ $menu_location ][ $key ]->href = '[mywp_url network_admin="1"]/settings.php';
          $default_toolbar[ $menu_location ][ $key ]->capability = 'manage_network_options';

        } elseif( $menu->id === 'my-sites-list' ) {

          $default_toolbar[ $menu_location ][ $key ]->capability = 'manage_network';

        } elseif( $menu->id === 'site-name' ) {

          $default_toolbar[ $menu_location ][ $key ]->href = '[mywp_url]';

        } elseif( $menu->id === 'view-site' ) {

          $default_toolbar[ $menu_location ][ $key ]->href = '[mywp_url]';

        } elseif( $menu->id === 'edit-site' ) {

          $default_toolbar[ $menu_location ][ $key ]->href = '[mywp_url network_admin="1"]/site-info.php?id=[mywp_site field="id"]';
          $default_toolbar[ $menu_location ][ $key ]->capability = 'manage_sites';

        } elseif( $menu->id === 'updates' ) {

          $default_toolbar[ $menu_location ][ $key ]->title = sprintf( '<span class="ab-icon"></span><span class="ab-label">%s</span>' , '[mywp_update_count]' );

        } elseif( $menu->id === 'comments' ) {

          $default_toolbar[ $menu_location ][ $key ]->title = sprintf( '<span class="ab-icon"></span><span class="ab-label awaiting-mod pending-count count-%1$s" aria-hidden="true">%1$s</span>' , '[mywp_comment_count]' );
          $default_toolbar[ $menu_location ][ $key ]->capability = 'edit_posts';

        } elseif( $menu->id === 'new-media' ) {

          $default_toolbar[ $menu_location ][ $key ]->capability = 'upload_files';

        } elseif( $menu->id === 'new-user' ) {

          $default_toolbar[ $menu_location ][ $key ]->capability = 'create_users';

        }

        $post_types = get_post_types( array( 'show_in_admin_bar' => true ) , 'objects' );

        foreach( $post_types as $post_type_object ) {

          if( ! empty( $default_toolbar[ $menu_location ][ $key ]->capability ) ) {

            continue;

          } elseif( $menu->id !== 'new-' . $post_type_object->name ) {

            continue;

          }

          $default_toolbar[ $menu_location ][ $key ]->capability = $post_type_object->cap->create_posts;

        }

      }

    }

    return $default_toolbar;

  }

  public static function delete_current_toolbar_items() {

    $args = array(
      'post_status' => array( 'publish' , 'draft' ),
      'post_type' => self::$post_type,
      'order' => 'ASC',
      'orderby' => 'menu_order',
      'posts_per_page' => -1,
      'tax_query' => array(
        array(
          'taxonomy' => 'mywp_term',
          'field' => 'slug',
          'terms' => 'default',
        ),
      ),
    );

    $current_setting_toolbar_item_posts = MywpSetting::get_posts( $args );

    if( ! empty( $current_setting_toolbar_item_posts ) ) {

      foreach( $current_setting_toolbar_item_posts as $key => $post ) {

        wp_delete_post( $post->ID );

      }

    }

    $mywp_transient = new MywpTransient( 'admin_toolbar_get_toolbar' , 'controller' );

    $mywp_transient->remove_data();

  }

  private static function get_wpauc_record_data_admin_bar_menu() {

    $wpauc_setting_data = MywpSettingScreenWPAUC_Importer::get_wpauc_record_data( 'admin_bar_menu' );

    if( ! empty( $wpauc_setting_data ) ) {

      $found_my_sites_item_key = false;

      foreach( $wpauc_setting_data as $wpauc_menu_location => $wpauc_menus ) {

        if( ! is_array( $wpauc_menus ) ) {

          unset( $wpauc_setting_data[ $wpauc_menu_location ] );

        }

        foreach( $wpauc_menus as $wpauc_menu_depth => $wpauc_menu_items ) {

          foreach( $wpauc_menu_items as $wpauc_menu_item_key => $wpauc_menu_item ) {

            if( $wpauc_menu_item['id'] === 'my-sites' ) {

              $found_my_sites_item_key = $wpauc_menu_item_key;

            }

            if( $wpauc_menu_item['id'] === 'network-admin' ) {

              $wpauc_menu_item['parent'] = '';

              unset( $wpauc_setting_data[ $wpauc_menu_location ][ $wpauc_menu_depth ][ $wpauc_menu_item_key ] );

              if( $found_my_sites_item_key ) {

                $wpauc_setting_data[ $wpauc_menu_location ]['main'][ $found_my_sites_item_key . '.5' ] = $wpauc_menu_item;

              } else {

                $wpauc_setting_data[ $wpauc_menu_location ]['main'][] = $wpauc_menu_item;

              }

            }

            if( is_multisite() ) {

              if( preg_match( '/^blog-[1-9](.*)+$/' , $wpauc_menu_item['id'] ) ) {

                unset( $wpauc_setting_data[ $wpauc_menu_location ][ $wpauc_menu_depth ][ $wpauc_menu_item_key ] );

              }

            }

          }

        }

      }

      if( $found_my_sites_item_key ) {

        foreach( $wpauc_setting_data as $wpauc_menu_location => $wpauc_menus ) {

          foreach( $wpauc_menus as $wpauc_menu_depth => $wpauc_menu_items ) {

            ksort( $wpauc_menu_items );

            $wpauc_setting_data[ $wpauc_menu_location ][ $wpauc_menu_depth ] = $wpauc_menu_items;

          }

        }

      }

    }

    return $wpauc_setting_data;

  }

  public static function toolbar_regist( $menu_location , $find_parent_item_id = false , $parent_post_id = 0 , $menu_order = 0 ) {

    $menu_location = strip_tags( $menu_location );

    $find_parent_item_id = strip_tags( $find_parent_item_id );

    $parent_post_id = intval( $parent_post_id );

    $menu_order = intval( $menu_order );

    $wpauc_setting_data = self::get_wpauc_record_data_admin_bar_menu();

    $find_items = array();

    foreach( $wpauc_setting_data as $wpauc_menu_location => $wpauc_menus ) {

      if( ! is_array( $wpauc_menus ) ) {

        continue;

      }

      if( $menu_location !== $wpauc_menu_location ) {

        continue;

      }

      foreach( $wpauc_menus as $wpauc_menu_depth => $wpauc_menu_items ) {

        foreach( $wpauc_menu_items as $wpauc_menu_item ) {

          if( (string) $wpauc_menu_item['parent'] !== (string) $find_parent_item_id ) {

            continue;

          }

          if( $wpauc_menu_item['id'] === 'my-sites-super-admin' ) {

            MywpSettingScreenWPAUC_Importer::$errors[] = sprintf( '%s item changed location and format saved.' , $wpauc_menu_item['id'] );

            continue;

          }

          $find_items[ $menu_location ][ $wpauc_menu_item['id'] ] = $wpauc_menu_item;

        }

      }

    }

    if( empty( $find_items ) ) {

      return false;

    }

    $post_terms = array(
      array( 'taxonomy' => 'mywp_term' , 'term' => 'default' ),
    );

    foreach( $find_items as $find_menu_items ) {

      foreach( $find_menu_items as $find_menu_item ) {

        $add_meta_data = array();

        if( strpos( $find_menu_item['id'] , 'custom_node' ) !== false ) {

          if( ! empty( $find_menu_item['group'] ) ) {

            $add_meta_data = array(
              'item_type' => 'group',
              'item_location' => $menu_location,
              'item_meta' => array(),
            );

          } else {

            if( empty( $find_menu_item['href'] ) ) {

              $find_menu_item['href'] = '#';

            }

            $add_meta_data = array(
              'item_type' => 'link',
              'item_location' => $menu_location,
              'item_link_title' => MywpSettingScreenWPAUC_Importer::change_shortcode( $find_menu_item['title'] ),
              'item_link_url' => $find_menu_item['href'],
              'item_meta' => array(),
            );

            if( ! empty( $find_menu_item['meta']['target'] ) ) {

              $add_meta_data['item_link_attr'] = sprintf( 'target="%s"' , $find_menu_item['meta']['target'] );

            }

          }

        } else {

          $toolbar_find_default_position = self::toolbar_find_default_position( $find_menu_item );

          if( empty( $toolbar_find_default_position ) ) {

            MywpSettingScreenWPAUC_Importer::$errors[] = sprintf( 'Sorry, %s item can not saved.' , $find_menu_item['id'] );

            continue;

          } else {

            if( ! empty( $find_menu_item['group'] ) ) {

              $add_meta_data = array(
                'item_type' => 'group',
                'item_location' => $menu_location,
                'item_default_id' => $toolbar_find_default_position->id,
                'item_default_parent_id' => $toolbar_find_default_position->parent,
                'item_default_title' => $toolbar_find_default_position->title,
                'item_capability' => $toolbar_find_default_position->capability,
                'item_meta' => $toolbar_find_default_position->meta,
              );

            } else {

              $item_icon_class = self::toolbar_item_icon_class( $find_menu_item );

              if( ! empty( $item_icon_class ) ) {

                $toolbar_find_default_position->title = str_replace( '<span class="ab-icon"></span>' , '' , $toolbar_find_default_position->title );

                $find_menu_item['title'] = str_replace( '<span class="ab-icon"></span>' , '' , $find_menu_item['title'] );

              }

              $add_meta_data = array(
                'item_type' => 'default',
                'item_location' => $menu_location,
                'item_default_id' => $toolbar_find_default_position->id,
                'item_default_parent_id' => $toolbar_find_default_position->parent,
                'item_default_title' => $toolbar_find_default_position->title,
                'item_link_title' => MywpSettingScreenWPAUC_Importer::change_shortcode( $find_menu_item['title'] ),
                'item_link_url' => $toolbar_find_default_position->href,
                'item_icon_class' => $item_icon_class,
                'item_capability' => $toolbar_find_default_position->capability,
                'item_meta' => $toolbar_find_default_position->meta,
              );

              if( ! empty( $find_menu_item['meta']['target'] ) ) {

                $add_meta_data['item_link_attr'] = sprintf( 'target="%s"' , $find_menu_item['meta']['target'] );

              }

            }

          }

        }

        if( empty( $add_meta_data ) ) {

          continue;

        }

        $post_data = array( 'post_parent' => $parent_post_id , 'menu_order' => $menu_order );

        $add_post_id = MywpSettingScreenWPAUC_Importer::add_post( 'mywp_admin_toolbar' , $post_data , $add_meta_data , $post_terms );

        $menu_order++;

        if ( empty( $add_post_id ) ) {

          MywpSettingScreenWPAUC_Importer::$errors[] = sprintf( 'Sorry, %s item of %s can not add.' , $find_menu_item['id'] , $menu_location );

          continue;

        } elseif( is_wp_error( $add_post_id ) ) {

          MywpSettingScreenWPAUC_Importer::$errors[] = sprintf( 'Sorry, %s item of %s can not add [%s].' , $find_menu_item['id'] , $menu_location , $add_post_id->get_error_message() );

          continue;

        }

        self::toolbar_regist( $menu_location , $find_menu_item['id'] , $add_post_id , $menu_order );

      }

    }

  }

  private static function toolbar_find_default_position( $find_menu_item ) {

    if( empty( $find_menu_item ) ) {

      return false;

    }

    $admin_toolbar_items = self::get_default_admin_toolbar_items();

    $found_menu = false;

    foreach( $admin_toolbar_items as $lc => $ms ) {

      foreach( $ms as $menu_id => $menu ) {

        if( $menu_id === $find_menu_item['id'] ) {

          $found_menu = $menu;

          break;

        }

      }

    }

    return $found_menu;

  }

  private static function toolbar_item_icon_class( $item ) {

    $item_icon_class = '';

    $id = $item['id'];

    if( $id === 'menu-toggle' ) {

      $item_icon_class = 'dashicons-before dashicons-menu';

    } elseif( $id === 'wp-logo' ) {

      $item_icon_class = 'dashicons-before dashicons-wordpress';

    } elseif( $id === 'site-name' ) {

      $item_icon_class = 'dashicons-before dashicons-admin-home';

    } elseif( $id === 'updates' ) {

      $item_icon_class = 'dashicons-before dashicons-update';

    } elseif( $id === 'comments' ) {

      $item_icon_class = 'dashicons-before dashicons-admin-comments';

    } elseif( $id === 'new-content' ) {

      $item_icon_class = 'dashicons-before dashicons-plus';

    }

    return $item_icon_class;

  }

}

endif;
