<?php
/*
Plugin Name: My WP Extends WP Admin UI Customize Importer
Plugin URI: https://mywpcustomize.com/
Description: My WP Extends WP Admin UI Customize Importer
Version: 1.0
Author: gqevu6bsiz
Author URI: http://gqevu6bsiz.chicappa.jp/
Domain Path: /languages
My WP Test working: 1.10
*/

if ( ! defined( 'ABSPATH' ) ) {
  exit;
}

if ( ! class_exists( 'MywpExtendsWPAUC_Importer' ) ) :

final class MywpExtendsWPAUC_Importer {

  private static $instance;

  private function __construct() {}

  public static function get_instance() {

    if ( !isset( self::$instance ) ) {

      self::$instance = new self();

    }

    return self::$instance;

  }

  private function __clone() {}

  private function __wakeup() {}

  public static function init() {

    self::define_constants();
    self::include_classes();

    add_action( 'mywp_start' , array( __CLASS__ , 'mywp_start' ) );

  }

  private static function define_constants() {

    define( 'MYWP_WAUC_IMPORTER_NAME' , 'My WP Extends WP Admin UI Customize Importer' );
    define( 'MYWP_WAUC_IMPORTER_VERSION' , '1.0' );
    define( 'MYWP_WAUC_IMPORTER_PLUGIN_FILE' , __FILE__ );
    define( 'MYWP_WAUC_IMPORTER_PLUGIN_BASENAME' , plugin_basename( MYWP_WAUC_IMPORTER_PLUGIN_FILE ) );
    define( 'MYWP_WAUC_IMPORTER_PLUGIN_DIRNAME' , dirname( MYWP_WAUC_IMPORTER_PLUGIN_BASENAME ) );
    define( 'MYWP_WAUC_IMPORTER_PLUGIN_PATH' , plugin_dir_path( MYWP_WAUC_IMPORTER_PLUGIN_FILE ) );
    define( 'MYWP_WAUC_IMPORTER_PLUGIN_URL' , plugin_dir_url( MYWP_WAUC_IMPORTER_PLUGIN_FILE ) );
    define( 'MYWP_WAUC_IMPORTER_REQUIRED_MYWP_VERSION' , '1.11' );

  }

  private static function include_classes() {

    $dir = MYWP_WAUC_IMPORTER_PLUGIN_PATH . '/';

    require_once( $dir . 'admin-sidebar.php' );
    require_once( $dir . 'admin-toolbar.php' );

  }

  public static function mywp_start() {

    add_filter( 'mywp_setting_plugins_loaded_include_modules' , array( __CLASS__ , 'mywp_setting_plugins_loaded_include_modules' ) );

    add_filter( 'mywp_thirdparty_plugins_loaded_include_modules' , array( __CLASS__ , 'mywp_thirdparty_plugins_loaded_include_modules' ) );

    add_filter( 'mywp_setting_menus' , array( __CLASS__ , 'mywp_setting_menus' ) , 1000 );

    add_action( 'mywp_request_admin_manager' , array( __CLASS__ , 'mywp_request_admin_manager' ) );

  }

  public static function mywp_setting_plugins_loaded_include_modules( $includes ) {

    $dir = MYWP_WAUC_IMPORTER_PLUGIN_PATH . '/';

    $includes['mywp_wpauc_importer_setting'] = $dir . 'setting.php';

    return $includes;

  }

  public static function mywp_thirdparty_plugins_loaded_include_modules( $includes ) {

    $dir = MYWP_WAUC_IMPORTER_PLUGIN_PATH . '/';

    $includes['mywp_wpauc_importer_thirdparty_wauc'] = $dir . 'thirdparty-wauc.php';

    return $includes;

  }

  public static function mywp_setting_menus( $setting_menus ) {

    $setting_menus['wpauc_importer'] = array(
      'menu_title' => __( 'WPAUC Importer' , 'my-wp' ),
      'multiple_screens' => false,
    );

    return $setting_menus;

  }

  public static function mywp_request_admin_manager() {

    if( is_multisite() ) {

      add_filter( 'network_admin_plugin_action_links_' . MYWP_WAUC_IMPORTER_PLUGIN_BASENAME , array( __CLASS__ , 'plugin_action_links' ) , 10 , 4 );

    } else {

      add_filter( 'plugin_action_links_' . MYWP_WAUC_IMPORTER_PLUGIN_BASENAME , array( __CLASS__ , 'plugin_action_links' ) , 10 , 4 );

    }

  }

  private static function is_this_file( $plugin_file_name = false ) {

    if( empty( $plugin_file_name ) ) {

      return false;

    }

    $plugin_file_name = strip_tags( $plugin_file_name );

    if ( strpos( MYWP_WAUC_IMPORTER_PLUGIN_BASENAME , $plugin_file_name ) === false ) {

      return false;

    }

    return true;

  }

  public static function plugin_action_links( $actions , $plugin_file , $plugin_data , $context ) {

    if ( ! self::is_this_file( $plugin_file ) ) {

      return $actions;

    }

    $action_link = array( 'setting' => sprintf( '<a href="%1$s">%2$s</a>' , esc_url( admin_url( 'admin.php?page=mywp_wpauc_importer' ) ) , __( 'Settings' ) ) );

    $actions = wp_parse_args( $actions , $action_link );

    return $actions;

  }

}

MywpExtendsWPAUC_Importer::init();

endif;
